"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DisposableEvent = exports.CompositeDisposable = exports.Disposable = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Disposable =
/*#__PURE__*/
function () {
  function Disposable(block) {
    _classCallCheck(this, Disposable);

    if (!block) {
      throw new Error('A Disposable must be created with a dispose callback');
    }

    this.block = block;
  }

  _createClass(Disposable, [{
    key: "dispose",
    value: function dispose() {
      if (this.block) {
        this.block();
        delete this.block;
      }
    }
  }]);

  return Disposable;
}();

exports.Disposable = Disposable;

var CompositeDisposable =
/*#__PURE__*/
function (_Disposable) {
  _inherits(CompositeDisposable, _Disposable);

  function CompositeDisposable() {
    var _this;

    var disposables = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    _classCallCheck(this, CompositeDisposable);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CompositeDisposable).call(this, function () {
      for (var i = 0; i < _this.disposables.length; i++) {
        var disposable = _this.disposables[i];
        disposable.dispose();
      }
    }));
    _this.disposables = disposables;
    return _this;
  }

  _createClass(CompositeDisposable, [{
    key: "add",
    value: function add(disposable) {
      this.disposables.push(disposable);
    }
  }, {
    key: "remove",
    value: function remove(disposable) {
      var index = this.disposables.indexOf(disposable);

      if (index !== -1) {
        this.disposables.splice(index, 1);
      }
    }
  }]);

  return CompositeDisposable;
}(Disposable);

exports.CompositeDisposable = CompositeDisposable;

var DisposableEvent =
/*#__PURE__*/
function (_Disposable2) {
  _inherits(DisposableEvent, _Disposable2);

  function DisposableEvent(target, event, listener) {
    var _this2;

    _classCallCheck(this, DisposableEvent);

    var events = event.split(/\s+/g);

    if (typeof target.addEventListener === 'function') {
      _this2 = _possibleConstructorReturn(this, _getPrototypeOf(DisposableEvent).call(this, function () {
        return events.forEach(function (e) {
          return target.removeEventListener(e, listener);
        });
      }));
      events.forEach(function (e) {
        return target.addEventListener(e, listener);
      });
    } else if (typeof target.on === 'function') {
      _this2 = _possibleConstructorReturn(this, _getPrototypeOf(DisposableEvent).call(this, function () {
        return events.forEach(function (e) {
          return target.off(e, listener);
        });
      }));
      events.forEach(function (e) {
        return target.on(e, listener);
      });
    } else {
      throw new Error('The passed-in source must have either a addEventListener or on method');
    }

    return _possibleConstructorReturn(_this2);
  }

  return DisposableEvent;
}(Disposable);

exports.DisposableEvent = DisposableEvent;